/* gtk.c -- misc Gtk wrappers 
 *
 * Copyright(C) 2001-2002 Elisa Manara <e@entropika.net>
 * This code is released under the GPL License version 2 */

#include <gtk/gtk.h>
#include <stdio.h>
#include "melon.h"

void dialog_message (gchar *message)
{
	GtkWidget *dialog, *label, *button;
   
	dialog = gtk_dialog_new();
	label = gtk_label_new (message);
	button = gtk_button_new_with_label("Ok");

	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
		label, FALSE, FALSE, 5);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
		button, FALSE, FALSE, 0);

	gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all (dialog);
}

void set_style(void)
{
	GtkStyle *style;

	style = gtk_style_new();
	if((strcmp(cfg_data.color_style, "gtk_default")) == 0) {
		cfg_data.bgcolor = style->bg[0];
		cfg_data.fgcolor = style->fg[0];
		cfg_data.abgcolor = style->bg[GTK_STATE_ACTIVE];
		cfg_data.afgcolor = style->fg[GTK_STATE_ACTIVE];
	} else {
		style->bg[0] = cfg_data.bgcolor;
		style->bg[GTK_STATE_ACTIVE] = cfg_data.abgcolor;
		style->bg[GTK_STATE_PRELIGHT] = cfg_data.abgcolor;
		style->bg[GTK_STATE_SELECTED] = cfg_data.fgcolor;
		style->fg[0] = cfg_data.fgcolor;
		style->fg[GTK_STATE_ACTIVE] = cfg_data.afgcolor;
		style->fg[GTK_STATE_PRELIGHT] = cfg_data.afgcolor;
		style->fg[GTK_STATE_SELECTED] = cfg_data.bgcolor;
		style->text[0] = cfg_data.fgcolor;
		style->text[GTK_STATE_ACTIVE] = cfg_data.afgcolor;
		style->text[GTK_STATE_PRELIGHT] = cfg_data.afgcolor;
		style->text[GTK_STATE_SELECTED] = cfg_data.bgcolor;
		style->base[0] = cfg_data.abgcolor;
	}
	gtk_widget_set_default_style( style );
	gtk_style_unref (style);
}


